using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;

namespace OptimizingProjectLength_Windows
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.DataGrid InformationDataGrid;
		DataTable _informationDataTable = new DataTable();
		private OptimizationThread _optimizationThread;
		private Thread _thread;
		private Thread _controlThread;
		bool _paused = false;
		private System.ComponentModel.IContainer components;


		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private InterfaceComponents.Toolbar toolbar1;
		
		public static int PopulationSize;
		private System.Windows.Forms.Label LengthLabel;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label CostsLabel;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.PictureBox pictureBox2;
		private System.Windows.Forms.PictureBox pictureBox3;
		private System.Windows.Forms.PictureBox pictureBox4;
		private System.Windows.Forms.PictureBox pictureBox5;
		private System.Windows.Forms.PictureBox pictureBox6;
		public static int Iterations;
		private System.Windows.Forms.MenuItem menuItem3;
		private string[] _activities = new string[]{"1 - 2", "2 - 3", "3 - 4", "4 - 5", "4 - 6", "4 - 7", "5 - 7", "6 - 8", "7 - 9", "8 - 10", "9 - 11", "9 - 12", "10 - 13", "12 - 13"};

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			
			MainForm.PopulationSize = 100;
			MainForm.Iterations = 2000;

			_optimizationThread = new OptimizationThread(MainForm.PopulationSize, MainForm.Iterations);

			_thread = new Thread(new ThreadStart(_optimizationThread.Optimize));
			_controlThread = new Thread(new ThreadStart(this.Wait));
			

			toolbar1.MainToolBar.ButtonClick +=new ToolBarButtonClickEventHandler(MainToolBar_ButtonClick);

			_informationDataTable.Columns.Add("Aktivnost");
			_informationDataTable.Columns.Add("Normalno trajanje");
			_informationDataTable.Columns.Add("Minimalno trajanje");
			_informationDataTable.Columns.Add("Cijena skracenja");
			_informationDataTable.Columns.Add("Trenutno trajanje");
			_informationDataTable.Columns.Add("Troskovi skracenja");

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.InformationDataGrid = new System.Windows.Forms.DataGrid();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.toolbar1 = new InterfaceComponents.Toolbar();
			this.LengthLabel = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.CostsLabel = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.pictureBox2 = new System.Windows.Forms.PictureBox();
			this.pictureBox3 = new System.Windows.Forms.PictureBox();
			this.pictureBox4 = new System.Windows.Forms.PictureBox();
			this.pictureBox5 = new System.Windows.Forms.PictureBox();
			this.pictureBox6 = new System.Windows.Forms.PictureBox();
			((System.ComponentModel.ISupportInitialize)(this.InformationDataGrid)).BeginInit();
			this.SuspendLayout();
			// 
			// InformationDataGrid
			// 
			this.InformationDataGrid.BackgroundColor = System.Drawing.Color.White;
			this.InformationDataGrid.CaptionBackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(192)), ((System.Byte)(128)));
			this.InformationDataGrid.CaptionForeColor = System.Drawing.Color.Black;
			this.InformationDataGrid.CaptionText = "Informacije o projektu";
			this.InformationDataGrid.DataMember = "";
			this.InformationDataGrid.FlatMode = true;
			this.InformationDataGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.InformationDataGrid.Location = new System.Drawing.Point(16, 304);
			this.InformationDataGrid.Name = "InformationDataGrid";
			this.InformationDataGrid.PreferredColumnWidth = 100;
			this.InformationDataGrid.ReadOnly = true;
			this.InformationDataGrid.Size = new System.Drawing.Size(640, 285);
			this.InformationDataGrid.TabIndex = 15;
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem3,
																					  this.menuItem2});
			this.menuItem1.Text = "Pomoc";
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 0;
			this.menuItem3.Text = "Upute za koristenje";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.Text = "O programu";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// toolbar1
			// 
			this.toolbar1.BackColor = System.Drawing.Color.White;
			this.toolbar1.Location = new System.Drawing.Point(0, 0);
			this.toolbar1.Name = "toolbar1";
			this.toolbar1.Size = new System.Drawing.Size(664, 48);
			this.toolbar1.TabIndex = 16;
			// 
			// LengthLabel
			// 
			this.LengthLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.LengthLabel.ForeColor = System.Drawing.Color.Red;
			this.LengthLabel.Location = new System.Drawing.Point(552, 600);
			this.LengthLabel.Name = "LengthLabel";
			this.LengthLabel.TabIndex = 18;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.Color.Red;
			this.label1.Location = new System.Drawing.Point(448, 600);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(104, 23);
			this.label1.TabIndex = 17;
			this.label1.Text = "Trajanje projekta:";
			// 
			// CostsLabel
			// 
			this.CostsLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.CostsLabel.ForeColor = System.Drawing.Color.Red;
			this.CostsLabel.Location = new System.Drawing.Point(552, 632);
			this.CostsLabel.Name = "CostsLabel";
			this.CostsLabel.TabIndex = 20;
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label3.ForeColor = System.Drawing.Color.Red;
			this.label3.Location = new System.Drawing.Point(448, 632);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(104, 23);
			this.label3.TabIndex = 19;
			this.label3.Text = "Troskovi projekta:";
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(72, 56);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(520, 232);
			this.pictureBox1.TabIndex = 21;
			this.pictureBox1.TabStop = false;
			// 
			// pictureBox2
			// 
			this.pictureBox2.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox2.Image")));
			this.pictureBox2.Location = new System.Drawing.Point(72, 56);
			this.pictureBox2.Name = "pictureBox2";
			this.pictureBox2.Size = new System.Drawing.Size(520, 232);
			this.pictureBox2.TabIndex = 22;
			this.pictureBox2.TabStop = false;
			// 
			// pictureBox3
			// 
			this.pictureBox3.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox3.Image")));
			this.pictureBox3.Location = new System.Drawing.Point(72, 56);
			this.pictureBox3.Name = "pictureBox3";
			this.pictureBox3.Size = new System.Drawing.Size(520, 232);
			this.pictureBox3.TabIndex = 23;
			this.pictureBox3.TabStop = false;
			// 
			// pictureBox4
			// 
			this.pictureBox4.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox4.Image")));
			this.pictureBox4.Location = new System.Drawing.Point(72, 56);
			this.pictureBox4.Name = "pictureBox4";
			this.pictureBox4.Size = new System.Drawing.Size(520, 232);
			this.pictureBox4.TabIndex = 24;
			this.pictureBox4.TabStop = false;
			// 
			// pictureBox5
			// 
			this.pictureBox5.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox5.Image")));
			this.pictureBox5.Location = new System.Drawing.Point(72, 56);
			this.pictureBox5.Name = "pictureBox5";
			this.pictureBox5.Size = new System.Drawing.Size(520, 232);
			this.pictureBox5.TabIndex = 25;
			this.pictureBox5.TabStop = false;
			// 
			// pictureBox6
			// 
			this.pictureBox6.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox6.Image")));
			this.pictureBox6.Location = new System.Drawing.Point(72, 56);
			this.pictureBox6.Name = "pictureBox6";
			this.pictureBox6.Size = new System.Drawing.Size(520, 232);
			this.pictureBox6.TabIndex = 26;
			this.pictureBox6.TabStop = false;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.White;
			this.ClientSize = new System.Drawing.Size(664, 673);
			this.Controls.Add(this.pictureBox6);
			this.Controls.Add(this.pictureBox5);
			this.Controls.Add(this.pictureBox4);
			this.Controls.Add(this.pictureBox3);
			this.Controls.Add(this.pictureBox2);
			this.Controls.Add(this.pictureBox1);
			this.Controls.Add(this.CostsLabel);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.LengthLabel);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.toolbar1);
			this.Controls.Add(this.InformationDataGrid);
			this.MaximizeBox = false;
			this.Menu = this.mainMenu1;
			this.MinimizeBox = false;
			this.Name = "MainForm";
			this.Text = "Optimiranje trajanja projekta";
			this.Load += new System.EventHandler(this.MainForm_Load_1);
			((System.ComponentModel.ISupportInitialize)(this.InformationDataGrid)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void Wait()
		{
			do 
			{
				Thread.Sleep(100);
				toolbar1.IncrementProgressBar();
			} 
			while(_thread.IsAlive);

			toolbar1.SetCompleted();

			DisplayBestIndividual();

			_optimizationThread = new OptimizationThread(MainForm.PopulationSize, MainForm.Iterations);

			MessageBox.Show("Optimization complete!", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information);
		}

		private void MainToolBar_ButtonClick(object sender, ToolBarButtonClickEventArgs e)
		{

			switch(this.toolbar1.MainToolBar.Buttons.IndexOf(e.Button))
			{
				case 0:
				{
					DisplayBestIndividual();
					if(!_thread.IsAlive)
					{
						if(!_paused)
						{
							toolbar1.ResetProgressBar();
						}
						
						_thread = new Thread(new ThreadStart(_optimizationThread.Optimize));
						_thread.IsBackground = true;
						_thread.Start();
					
						_controlThread = new Thread(new ThreadStart(this.Wait));
						_controlThread.IsBackground = true;
						_controlThread.Start();
					}
					else
					{
						try
						{
							_thread.Resume();
							_controlThread.Resume();

						}
						catch
						{
							toolbar1.ResetProgressBar();
							
							_thread = new Thread(new ThreadStart(_optimizationThread.Optimize));
							_thread.IsBackground = true;
							_thread.Start();
							
							_controlThread = new Thread(new ThreadStart(Wait));
							_controlThread.IsBackground = true;
							_controlThread.Start();
						}
					}
					break;
				}
				case 1:
				{
					DisplayBestIndividual();
					try
					{
						if(_thread.ThreadState==ThreadState.Suspended)
						{
							_thread.Resume();
							_controlThread.Resume();
						}
						_thread.Suspend();
						_controlThread.Suspend();

						_paused = true;
					}
					catch
					{
					}

					break;
				}
				case 2:
				{
					DisplayBestIndividual();
					_paused = false;
					try
					{
						_thread.Abort();
						_controlThread.Abort();
					}
					catch
					{

					}
					
					_optimizationThread = new OptimizationThread(MainForm.PopulationSize, MainForm.Iterations);
					break;
				}
				case 3:
				{
					Configuration ConfigurationDialog = new Configuration();
					ConfigurationDialog.ShowDialog();
					_optimizationThread = new OptimizationThread(MainForm.PopulationSize, MainForm.Iterations);
					break;
				}
			}
		}

		private void DisplayBestIndividual()
		{
			_informationDataTable.Rows.Clear();

			int[] iJobsLenght = ((OptimizingProjectLength_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).JobsLength;
			int[] iNormalLengths = _optimizationThread.p.NormalLenght;
			int[] iShortenLengths = _optimizationThread.p.ShortenLength;
			float[] fCosts = _optimizationThread.p.Costs;

			for(int i=0; i<iJobsLenght.Length; i++)
			{
				_informationDataTable.Rows.Add(new object[]{_activities[i], iNormalLengths[i], iShortenLengths[i], fCosts[i], (iNormalLengths[i]-iJobsLenght[i]), iJobsLenght[i]*fCosts[i]});
			}
			
			InformationDataGrid.DataSource = _informationDataTable;

			CostsLabel.Text = (_optimizationThread.p.BestIndividual-((OptimizingProjectLength_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).ShortenLenght).ToString();
			LengthLabel.Text = ((OptimizingProjectLength_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).ShortenLenght.ToString();

			switch(((OptimizingProjectLength_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).CriticalPath) 
			{
				case 1:
					pictureBox1.Visible = true;
					pictureBox2.Visible = false;
					pictureBox3.Visible = false;
					pictureBox4.Visible = false;
					pictureBox5.Visible = false;
					pictureBox6.Visible = false;
					break;
				case 2:
					pictureBox1.Visible = false;
					pictureBox2.Visible = true;
					pictureBox3.Visible = false;
					pictureBox4.Visible = false;
					pictureBox5.Visible = false;
					pictureBox6.Visible = false;
					break;
				case 3:
					pictureBox1.Visible = false;
					pictureBox2.Visible = false;
					pictureBox3.Visible = true;
					pictureBox4.Visible = false;
					pictureBox5.Visible = false;
					pictureBox6.Visible = false;
					break;
				case 4:
					pictureBox1.Visible = false;
					pictureBox2.Visible = false;
					pictureBox3.Visible = false;
					pictureBox4.Visible = true;
					pictureBox5.Visible = false;
					pictureBox6.Visible = false;
					break;
				case 5:
					pictureBox1.Visible = false;
					pictureBox2.Visible = false;
					pictureBox3.Visible = false;
					pictureBox4.Visible = false;
					pictureBox5.Visible = true;
					pictureBox6.Visible = false;
					break;
				case 6:
					pictureBox1.Visible = false;
					pictureBox2.Visible = false;
					pictureBox3.Visible = false;
					pictureBox4.Visible = false;
					pictureBox5.Visible = false;
					pictureBox6.Visible = true;
					break;
			}


//			CostsLabel.Text = _optimizationThread.p.BestIndividual.ToString();
//			
//			ABLabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[0].ToString();
//			ACLabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[1].ToString();
//			BCLabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[2].ToString();
//			BELabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[3].ToString();
//			BDLabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[4].ToString();
//			CDLabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[5].ToString();
//			CELabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[6].ToString();
//			EDLabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[7].ToString();
//			DFLabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[8].ToString();
//			EFLabel.Text = ((Network_Kalpic67_Library.Individual)_optimizationThread.p[_optimizationThread.p.BestIndividualIndex]).Activities()[9].ToString();

		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			DisplayBestIndividual();
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show("      (c) Copyright - Toni Frankola 2005.\nFakultete elektrotehnike i racunarstva\n	     Zagreb", "O programu");
		}

		private void MainForm_Load_1(object sender, System.EventArgs e)
		{
			DisplayBestIndividual();
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			Help helpForm = new Help();
			helpForm.Show();
		}
	}
}
