using System;
using OptimizingProjectLength_Library;

namespace OptimizingProjectLength_Windows
{
	/// <summary>
	/// Summary description for OptimizationThread.
	/// </summary>
	public class OptimizationThread
	{
		public Population p;
		private int _populationSize;
		private int _iterations;

        private int[] _normalLenght = new int[]{2, 4, 10, 4, 6, 7, 5, 7, 8, 9, 4, 5, 2, 6};
		private int[] _shortenLength = new int[]{1, 3, 7, 2, 4, 5, 3, 4, 6, 5, 3, 3, 1, 3};
		
		private float[] _costs = new float[]{300, 200, 300, 350, 150, 100, 150, 200, 100, 100, 100, 150, 100, 133.3F};
		private int _costPerUnit = 200;
		private int _precision = 3;
		
		public OptimizationThread(int PopulationSize, int Iterations)
		{
			_populationSize = PopulationSize;
			_iterations = Iterations;
			p = new Population(_populationSize, 0.5, 0.1, _iterations, _precision, _normalLenght, _shortenLength, _costs, _costPerUnit, OptimizationType.SampleProject);
			p.CalculatePunishment();
		}

		public void Optimize()
		{
			int iIterations = 0;
			p = new Population(_populationSize, 0.5, 0.1, _iterations, _precision, _normalLenght, _shortenLength, _costs, _costPerUnit, OptimizationType.SampleProject);
			p.CalculatePunishment();
			
			p.Optimize(ref iIterations);
			p.CalculatePunishment();
		}
	}
}
